/*
	Copyright 1995 Ogasawara Hiroyuki(COR.)
		modified by Rick 1998

*/

#include	<corlib.h>
#include	<sys_doslib.h>
#include	"gview.h"
#include	"PICSLICE.H"

extern void	PPMcombine( GVIEW*, unsigned char* );
extern void	PPMcombine2( GVIEW*, unsigned char*, int );
extern void	psierr( char*, int );

static unsigned char *
getnum( ptr, num )
unsigned char	*ptr;
int	*num;
{
	int	i= 0;
	for(; *ptr && *ptr <= ' ' ; ptr++ );
	for(; *ptr >= '0' && *ptr <= '9' ;)
		i= i*10+ (*ptr++&15);
	*num= i;
	return	ptr;
}

static unsigned char *
putnum( str, num )
unsigned char	*str;
int	num;
{
	char	buf[20], *p= buf+20;
	*--p= '\0';
	do{
		*--p= num%10 +'0';
	}while( num/= 10 );
	for(; *str++= *p++ ;);
	return	str-1;
}

GVIEW *
GV_Load_Ppm( fname )
char	*fname;
{
	char	format[]= "PPM";
	int	fn, len;
	unsigned char	*ptr;
	int	color;
	GVIEW	*gp;

	if( (fn= OPEN( fname, 0 )) < 0 ){
		psierr( format, PICSLICE_EOPEN );
		return	NULL;
	}
	len= SEEK( fn, 0, 2 );
	SEEK( fn, 0, 0 );
	if( !(gp= GV_Alloc( 0, 0, WindowAttrGraphic65536,
						fname, NULL, len )) ){
		CLOSE( fn );
		psierr( format, PICSLICE_NOMEMORY );
		return	NULL;
	}
	ptr= (unsigned char*)gp->buf;
	if(	READ( fn, ptr, len ) < 0 ){
		CLOSE( fn );
		psierr( format, PICSLICE_EREAD );
		MFREE( gp );
		return	NULL;
	}
	CLOSE( fn );
	if( *ptr != 'P' || *(ptr+1) != '6' ){
		psierr( format, PICSLICE_EFORMAT );
		MFREE( gp );
		return	NULL;
	}
	ptr= getnum( ptr+2, &gp->h );
	ptr= getnum( ptr, &gp->v );
	ptr= getnum( ptr, &color );
	if( !color ){
		psierr( format, PICSLICE_EFORMAT );
		MFREE( gp );
		return	NULL;
	}
	if( *ptr == '\r' || *ptr == '\n' )	ptr++;
	if( *ptr == '\r' || *ptr == '\n' )	ptr++;
	if( color == 255 ){
		PPMcombine( gp, ptr );
	}else {
		PPMcombine2( gp, ptr, color );
	}
	SETBLOCK( gp, ((char*)gp->buf) - (char*)gp + gp->h*gp->v*2 );
	return gp;
}
